package com.esk.tree;

import org.objectweb.asm.tree.AbstractInsnNode;
import org.objectweb.asm.tree.LabelNode;

import com.esk.util.List;

public class Target extends Node {
  protected List<JumpNode> ts = new List<JumpNode>();

  public Target(NodeTree t, AbstractInsnNode ai, int c, int p) {
    super(t, ai, c, p);
  }

  public JumpNode[] targeters() {
    return ts.array(JumpNode.class);
  }

  public Node resolve() {
    Node n = this;
    while(n != null && n.op() == -1)
      n = n.next();
    if(n == null)
      n = owner();
    return n;
  }

  public LabelNode insn() {
    return (LabelNode)ai;
  }

  public String toString(int i) {
    return getClass().getName() + "@" + Integer.toHexString(ai.hashCode());
  }
}