package com.esk.deob.impl;

import org.objectweb.asm.tree.*;

import com.esk.deob.Transform;
import com.esk.tree.*;

public class ObnoxiousShift extends Transform {
  private static int i = 0;

  public void printResult() {
    System.out.println("corrected " + i + " obnoxious shifts");
  }

  public void visit(Node n) {
    int o = n.op();
    if(o >= ISHL && o <= LUSHR) {
      Node[] p = n.producing();
      if(p.length != 2)
        return;
      Node n2 = p[1];
      if(n2 instanceof NumberNode) {
        NumberNode nn = (NumberNode)n2;
        int v = nn.value().intValue();
        nn.setValue(v & (o == ISHL || o == ISHR || o == IUSHR ? 31 : 63));
        i++;
      }
    }
  }

  public boolean accept(ClassNode cn) {
    return true;
  }

  public boolean accept(MethodNode mn) {
    return true;
  }
}