package com.esk.deob.impl;

import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.LdcInsnNode;
import org.objectweb.asm.tree.MethodNode;

import com.esk.deob.Transform;
import com.esk.tree.Node;

public class ServerAddress extends Transform {
  public void printResult() { }

  public void visitLdc(Node n) {
    LdcInsnNode li = (LdcInsnNode)n.insn();
    if(li.cst.equals("127.0.0.1"))
      li.cst = "world63.runescape.com";
  }

  public boolean accept(ClassNode cn) {
    return cn.name.equals("client");
  }

  public boolean accept(MethodNode mn) {
    return true;
  }
}