package com.esk.tree;

import java.io.File;
import java.io.FileInputStream;
import java.util.List;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.Opcodes;
import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.InsnNode;
import org.objectweb.asm.tree.MethodNode;

public class Main {
  public void test(int x, int y, boolean b) {
    try {
      int z = x & y;
      test(z, x, b);
    } catch(RuntimeException e) {
      throw e;
    }
  }

  public static void main(String[] args) throws Throwable {
    ClassReader cr = new ClassReader(new FileInputStream(new File("com/esk/tree/Main.class")));
    ClassNode cn = new ClassNode();
    cr.accept(cn, ClassReader.SKIP_FRAMES);
    for(MethodNode mn : (List<MethodNode>)cn.methods) {
      if(!mn.name.equals("test"))
        continue;
      NodeTree t = new NodeTree(mn);
      t.build();
      /*t.accept(new VisitorAdapter() {
        public void visitJump(JumpNode jn) {
          System.out.println(jn);
          for(Node n : ns) {
            n.popTail();
            jn.remove(n);
          }
          System.out.println(jn);
        }
      });*/
      System.out.println(t);
    }
  }
}