package com.esk.tree;

public interface Visitor {
  public void visit(Node n);
  public void visitInt(Node n);
  public void visitVar(Node n);
  public void visitType(Node n);
  public void visitField(InvocationNode in);
  public void visitMethod(InvocationNode in);
  public void visitJump(JumpNode n);
  public void visitLabel(Node n);
  public void visitLdc(Node n);
  public void visitIinc(Node n);
  public void visitTableSwitch(Node n);
  public void visitLookupSwitch(Node n);
  public void visitMultiANewArray(Node n);
  public void visitFrame(Node n);
  public void visitLine(Node n);
}